//+------------------------------------------------------------------+
//|                                                      .mq4 |
//|                                         Copyright  2007, DRKNN. |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, DRKNN"

//extern bool     UseAutolot=false;//    
//extern int      Risk=2;//  
extern double   Lot=0.2;
extern int      Zazor=2;//   -    
extern bool     UseSound = true;  //   
extern string   NameSound  = "expert.wav";  //   

// -------   --------------
string SMB;
int    MinLevel,digits,SPR,SchBuy,SchSell;
double MinLots,SL,TP;
bool   SigBuy,SigSell,CloseBuy,CloseSell;
int    Proskalz;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init(){
  
   if (!IsTesting()) {
     if(!IsExpertEnabled()) {
       Alert("!    **");
       Comment("!    **   .");
       return(0);
     }
     else {
       Comment("  .   .");
       Print("  .   .");
     }
   }
   return(0);
  
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Print("  ( )");
Comment(""); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start(){
  if(Lot<MinLots){
    Alert("!   .   = ",MinLots);
    return(0);
  }
  
  SMB=Symbol();
  MinLots=(MarketInfo(SMB,MODE_MINLOT));
  MinLevel=MarketInfo(SMB,MODE_STOPLEVEL);
  SPR=MarketInfo(SMB,MODE_SPREAD);
  Proskalz=SPR;
  digits=MarketInfo(SMB,MODE_DIGITS);
 
  // --------   ------------------------
  SchOrders();
  if(SchBuy>0){
    if(!IsTradeAllowed()){
      Alert(SMB,".     ,    ");
      return(0);
    }
    for (int a=OrdersTotal()-1;a>=0;a--){
       if (!OrderSelect(a, SELECT_BY_POS, MODE_TRADES)){
         WriteError(a);
         Print("     Buy- (OrderSelect)");
         continue;
       }
       else{
         if(OrderSymbol()!=SMB) {continue;} //    -  
         if(OrderType()==OP_BUY){
           if(OrderStopLoss()<Point){
             SL=FractalDOWN()-Zazor*Point;
             SL=NormalizeDouble(SL,digits);
             Print(SMB," SL = ",SL);
             if(Ask-SL<MinLevel*Point){return(0);}
             else{
               if(!OrderModify(OrderTicket(),OrderOpenPrice(),SL,OrderTakeProfit(),0,CLR_NONE)){
                 ModifError(a);
                 Print("     Buy- (OrderModify)");
               }  
             } 
           }
         }
       }       
    }         
  }
  if(SchSell>0){
    if(!IsTradeAllowed()){
      Alert(SMB,".     ,    ");
      return(0);
    }
    for (int b=OrdersTotal()-1;b>=0;b--){
       if (!OrderSelect(b, SELECT_BY_POS, MODE_TRADES)){
         WriteError(b);
         Print("     Sell- (OrderSelect)");
         continue;
       }  
       else{
         if(OrderSymbol()!=SMB) {continue;}
         if(OrderType()==OP_SELL){
           if(OrderStopLoss()<Point){
             SL=FractalUP()+Zazor*Point;
             SL=NormalizeDouble(SL,digits);
             Print(SMB," SL = ",SL);
             if(SL-Bid<MinLevel*Point){return(0);}
             else{
               if(!OrderModify(OrderTicket(),OrderOpenPrice(),SL,OrderTakeProfit(),0,CLR_NONE)){
                 ModifError(b);
                 Print("     Sell- (OrderModify)");
               }
             }  
           }
         }
       }      
    }           
  }

   return(0);
  }
//+------------------------------------------------------------------+


//==========   ======================

//===========     =================================================================
//   SchOrders()      ,      .
//   SchBuy      -  Buy 
//   SchSell     -  Sell 
//----------------------------------------------------------------------------------------------------------
void SchOrders(){
  SchBuy=0;
  SchSell=0;
  for (int sch=OrdersTotal()-1;sch>=0;sch--){
    if (!OrderSelect(sch, SELECT_BY_POS, MODE_TRADES)){
      WriteError(sch);
      Print("      (OrderSelect)");
      continue;
    }
    else{
      if(OrderSymbol()!=SMB) {continue;} //    -  
      if(OrderType()==OP_BUY){
        SchBuy++;
      } 
      if(OrderType()==OP_SELL){
        SchSell++;
      } 
    }
  }
}                  
//==========================================================================================================


// ================= FractalUP() =====================================
//      
//---------------------------------------------------------
double FractalUP(){
  double FractalUP=0;
  for(int fup=1;fup<Bars;fup++){
    FractalUP=iCustom(SMB,0,"Fractal_Sounds",0,fup);
    if(FractalUP!=0){break;}
  }
  return(FractalUP);
}
// ===================================================================

// ================= FractalDOWN() =====================================
//      
//---------------------------------------------------------
double FractalDOWN(){
  double FractalDOWN=0;
  for(int fdn=1;fdn<Bars;fdn++){
    FractalDOWN=iCustom(SMB,0,"Fractal_Sounds",1,fdn);
    if(FractalDOWN!=0){break;}
  }
  return(FractalDOWN);
}
// ===================================================================

// =======================        ==========================================
//    WriteError()         
// --------------------------------------------------------------------------------

void WriteError(int wer){
 int GLE=GetLastError(); 
 string ED=ErrorDescription(GLE);
 Print(" ", GLE, "     ",wer);
 Print ("  - ",ED);
}
// =========================================================================================================


// =======================   =====================================================
//   ModifError()         
// ------------------------------------------------------------------------------------
void ModifError(int mer){
 int GLE=GetLastError();
 string ED=ErrorDescription(GLE);
 Print("   ",mer, "    ",GLE);
 Print (" : ",ED);
}
// ================================================================================================

//=========    ===============================
//  ErrorDescription()        
//-----------------------------------------------------------
string ErrorDescription(int error_code){
      string error_string;
      switch(error_code)
        {
         //---- codes returned from trade server
           case 0:      error_string="  "; break;
           case 1:      error_string="  ,   "; break;
           case 2:      error_string="  "; break;
           case 3:      error_string="  "; break;
           case 4:      error_string="   "; break;
           case 5:      error_string="    "; break;
           case 6:      error_string="     "; break;
           case 7:      error_string="  "; break;
           case 8:      error_string="   "; break;
           case 9:      error_string="     "; break;
           case 64:     error_string="  "; break;
           case 65:     error_string="   "; break;
           case 128:    error_string="     "; break;
           case 129:    error_string="  "; break;
           case 130:    error_string="  "; break;
           case 131:    error_string="  "; break;
           case 132:    error_string="  "; break;
           case 133:    error_string="  "; break;
           case 134:    error_string="     "; break;
           case 135:    error_string="  "; break;
           case 136:    error_string="  "; break;
           case 137:    error_string="  "; break;
           case 138:    error_string="  "; break;
           case 139:    error_string="     "; break;
           case 140:    error_string="   "; break;
           case 141:    error_string="   "; break;
           case 145:    error_string="  ,       "; break;
           case 146:    error_string="   "; break;
           case 147:    error_string="      "; break;
           case 148:    error_string="       ,  "; break;
           case 4000:   error_string="  "; break;
           case 4001:   error_string="   "; break;
           case 4002:   error_string="   -  "; break;
           case 4003:   error_string="     "; break;
           case 4004:   error_string="     "; break;
           case 4005:   error_string="       "; break;
           case 4006:   error_string="     "; break;
           case 4007:   error_string="     "; break;
           case 4008:   error_string="  "; break;
           case 4009:   error_string="    "; break;
           case 4010:   error_string="     "; break;
           case 4011:   error_string="   "; break;
           case 4012:   error_string="     "; break;
           case 4013:   error_string="   "; break;
           case 4014:   error_string="  "; break;
           case 4015:   error_string="  "; break;
           case 4016:   error_string="  "; break;
           case 4017:   error_string="  DLL  "; break;
           case 4018:   error_string="   "; break;
           case 4019:   error_string="   "; break;
           case 4020:   error_string="      "; break;
           case 4021:   error_string="    ,   "; break;
           case 4022:   error_string="  "; break;
           case 4050:   error_string="    "; break;
           case 4051:   error_string="    "; break;
           case 4052:   error_string="    "; break;
           case 4053:   error_string="  "; break;
           case 4054:   error_string="   -"; break;
           case 4055:   error_string="   "; break;
           case 4056:   error_string="  "; break;
           case 4057:   error_string="    "; break;
           case 4058:   error_string="    "; break;
           case 4059:   error_string="      "; break;
           case 4060:   error_string="   "; break;
           case 4061:   error_string="   "; break;
           case 4062:   error_string="    string"; break;
           case 4063:   error_string="    integer"; break;
           case 4064:   error_string="    double"; break;
           case 4065:   error_string="     "; break;
           case 4066:   error_string="      "; break;
           case 4067:   error_string="     "; break;
           case 4099:   error_string="  "; break;
           case 4100:   error_string="     "; break;
           case 4101:   error_string="   "; break;
           case 4102:   error_string="    "; break;
           case 4103:   error_string="   "; break;
           case 4104:   error_string="     "; break;
           case 4105:   error_string="     "; break;
           case 4106:   error_string="  "; break;
           case 4107:   error_string="      "; break;
           case 4108:   error_string="   "; break;
           case 4109:   error_string="   "; break;
           case 4110:   error_string="    "; break;
           case 4111:   error_string="    "; break;
           case 4200:   error_string="   "; break;
           case 4201:   error_string="    "; break;
           case 4202:   error_string="   "; break;
           case 4203:   error_string="   "; break;
           case 4204:   error_string="   "; break;
           case 4205:   error_string="   "; break;
           case 4206:   error_string="    "; break;
           case 4207:   error_string="     "; break;
        }
  
  return(error_string);
}
//===============================================================================================================================

